100 REMark Convert QDOS font to printer download fonts,
110 REMark     9 or 24 pin, draft or NLQ, dot matrix
120 REMark by Dilwyn Jones, July 1994, requires Toolkit 2
130 REMark              PUBLIC DOMAIN PROGRAM
140 :
150 CLS:CLS#0
160 INPUT#0,'Filename of QL font to convert:';ip$
170 IF ip$='' THEN STOP
180 INPUT#0,'Filename to save converted font:';op$
190 IF op$='' THEN STOP
200 INPUT#0,'Convert to 9 pin or 24 pin font (Enter 9 or 2):';pins$
210 IF pins$ = '' THEN STOP
220 INPUT#0,'Convert to draft or NLQ font (Enter D or N):';quality$
230 IF quality$ = '' THEN STOP
240 :
250 length = FLEN(\ip$)
260 IF length <= 0 THEN 
270   PRINT#0,"Oops, error ";length
280   STOP
290 END IF 
300 :
310 base=ALCHP(length)
320 IF base<0 THEN 
330   PRINT#0,'Out of memory.'
340   STOP
350 END IF 
360 :
370 LBYTES ip$,base
380 :
390 lowest_char% = PEEK(base)
400 highest_char% = lowest_char% + PEEK(base+1)
410 IF highest_char% < lowest_char% THEN 
420   PRINT#0,'Invalid character range.'
430   RECHP base : STOP
440 END IF 
450 :
460 PRINT#0,'Character range ';lowest_char%;' to ';highest_char%
470 :
480 REPeat loop
490   INPUT#0,'Convert from character code:';fc%
500   IF fc%>=lowest_char% AND fc%<=highest_char% THEN EXIT loop
510   BEEP 5000,50
520 END REPeat loop
530 :
540 REPeat loop
550   INPUT#0,'To character code:';tc%
560   IF tc%>=lowest_char% AND tc%<=highest_char% THEN EXIT loop
570   BEEP 5000,50
580 END REPeat loop
590 :
600 ch = FOP_NEW(#3,op$) : REMark file to hold download font
610 IF ch<0 THEN 
620   REMark oops, failed to open file "op$"
630   RECHP base : REMark don't forget this!
640   PRINT#0,'Oops, error ';ch
650   STOP
660 END IF 
670 :
680 REMark start converting
690 CLS : PRINT'Converting CHR$:';
700 :
710 IF quality$ == 'N' THEN 
720   IF pins$ = '9' THEN 
730     TO_9PIN_NLQ
740   ELSE 
750     TO_24PIN_NLQ
760   END IF 
770 ELSE 
780   IF pins$ = '9' THEN 
790     TO_9PIN_DRAFT
800   ELSE 
810     TO_24PIN_DRAFT
820   END IF 
830 END IF 
840 RECHP base
850 CLOSE #3
860 CLS #0 : PRINT #0,'PROGRAM FINISHED.'
870 STOP
880 :
890 DEFine PROCedure TO_9PIN_DRAFT
900   REMark convert to 9 pin draft download font format, 11 across x 8 down
910   BPUT#3,27,CODE('x'),0 : REMark draft
920   BPUT#3,27,CODE('&'),0,fc%,tc%
930   :
940   FOR c = fc% TO tc%
950     PRINT ! c !
960     char_base = base+2+((c-lowest_char%)*9)
970     DIM byte(9)
980     FOR a = 0 TO 8 : byte(a) = PEEK(char_base+a)
990     REMark 9 pin draft can only be 8 lines high
1000     fromline%=0:toline%=8
1010     IF byte(8)<>0 AND byte(0)=0 THEN 
1020       fromline%=1
1030     ELSE 
1040       toline%=7
1050     END IF 
1060     REMark transfer lines 0 to 7 or 1 to 8 to download font
1070     DIM dnfnt(10)
1080     vert_bit = 128
1090     FOR lne=fromline% TO toline%
1100       across = 0
1110       FOR x = 64,32,16,8,4
1120         IF byte(lne)&&x:dnfnt(across)=dnfnt(across)||vert_bit
1130         across = across + 2
1140       END FOR x
1150       vert_bit = vert_bit DIV 2
1160     END FOR lne
1170     attr=0
1180     IF fromline% = 0 THEN attr=128
1190     PRINT#3,CHR$(attr);
1200     FOR a = 0 TO 10 : PRINT#3,CHR$(dnfnt(a));
1210   END FOR c
1220 END DEFine TO_9PIN_DRAFT
1230 :
1240 DEFine PROCedure TO_9PIN_NLQ
1250   BPUT#3,27,CODE('x'),1 : REMark NLQ
1260   BPUT#3,27,CODE('&'),0,fc%,tc%
1270   FOR c = fc% TO tc%
1280     PRINT ! c !
1290     char_base = base+2+((c-lowest_char%)*9)
1300     DIM byte(9)
1310     FOR a = 0 TO 8 : byte(a) = PEEK(char_base+a)
1320     REMark 9 pin draft can only be 8 lines high
1330     fromline%=0:toline%=8
1340     IF byte(8)<>0 AND byte(0)=0 THEN 
1350       fromline%=1
1360     ELSE 
1370       toline%=7
1380     END IF 
1390     REMark transfer lines 0 to 7 or 1 to 8 to download font
1400     DIM dnfnt(45)
1410     vert_bit = 128 : vert_bit2 = 64
1420     FOR lne = fromline% TO toline%
1430       across = 0
1440       FOR x = 64,32,16,8,4
1450         IF byte(lne) && x THEN 
1460           dnfnt(across) = dnfnt(across) || vert_bit
1470           dnfnt(across+4) = dnfnt(across+4) || vert_bit
1480           dnfnt(across+2) = dnfnt(across+2) || vert_bit2
1490           dnfnt(across+6) = dnfnt(across+6) || vert_bit2
1500         END IF 
1510         across = across + 8
1520       END FOR x
1530       vert_bit = vert_bit DIV 2  : IF vert_bit = 0 THEN vert_bit = 128
1540       vert_bit2 = vert_bit2 DIV 2: IF vert_bit2 = 0 THEN vert_bit2 = 128
1550     END FOR lne
1560     attr = 0
1570     IF fromline% = 0 THEN attr = 128
1580     PRINT #3,CHR$(attr);
1590     FOR a = 0 TO 45 : PRINT #3,CHR$(dnfnt(a));
1600   END FOR c
1610 END DEFine TO_9PIN_NLQ
1620 :
1630 DEFine PROCedure TO_24PIN_DRAFT
1640   BPUT#3,27,CODE('x'),0 : REMark draft
1650   BPUT#3,27,CODE('&'),0,fc%,tc%
1660   FOR c = fc% TO tc%
1670     PRINT ! c !
1680     char_base = base+2+((c-lowest_char%)*9)
1690     DIM byte(9)
1700     FOR a = 0 TO 8 : byte(a) = PEEK(char_base+a)
1710     REMark transfer lines 0 to 7 or 1 to 8 to download font
1720     DIM dnfnt(27)
1730     vert_bit1 = 128 : vert_bit2 = 64
1740     start_across = 0
1750     FOR lne = 0 TO 8
1760       across = start_across
1770       FOR x = 64,32,16,8,4
1780         IF byte(lne) && x THEN 
1790           dnfnt(across) = dnfnt(across) || vert_bit1
1800           dnfnt(across) = dnfnt(across) || vert_bit2
1810         END IF 
1820         across = across + 6
1830       END FOR x
1840       vert_bit1 = vert_bit1 DIV 4 : vert_bit2 = vert_bit2 DIV 4
1850       IF vert_bit1 = 0 THEN 
1860         vert_bit1 = 128 : vert_bit2 = 64
1870         start_across = start_across + 1
1880       END IF 
1890     END FOR lne
1900     PRINT#3,CHR$(1);CHR$(9);CHR$(1);
1910     FOR a = 0 TO 26 : PRINT#3,CHR$(dnfnt(a));
1920   END FOR c
1930 END DEFine TO_24PIN_DRAFT
1940 :
1950 DEFine PROCedure TO_24PIN_NLQ
1960   BPUT#3,27,CODE('x'),1 : REMark NLQ
1970   BPUT#3,27,CODE('&'),0,fc%,tc%
1980   FOR c = fc% TO tc%
1990     PRINT ! c !
2000     char_base = base+2+((c-lowest_char%)*9)
2010     DIM byte(9)
2020     FOR a = 0 TO 8 : byte(a) = PEEK(char_base+a)
2030     REMark transfer lines 0 to 7 or 1 to 8 to download font
2040     DIM dnfnt(59)
2050     vert_bit1 = 128 : vert_bit2 = 64
2060     start_across = 0
2070     FOR lne = 0 TO 8
2080       across = start_across
2090       FOR x = 64,32,16,8,4
2100         IF byte(lne) && x THEN 
2110           dnfnt(across) = dnfnt(across) || vert_bit1
2120           dnfnt(across+3) = dnfnt(across+3) || vert_bit2
2130           dnfnt(across+6) = dnfnt(across+6) || vert_bit1
2140           dnfnt(across+9) = dnfnt(across+9) || vert_bit2
2150         END IF 
2160         across = across + 12
2170       END FOR x
2180       vert_bit1 = vert_bit1 DIV 4 : vert_bit2 = vert_bit2 DIV 4
2190       IF vert_bit1 = 0 THEN 
2200         vert_bit1 = 128 : vert_bit2 = 64
2210         start_across = start_across + 1
2220       END IF 
2230     END FOR lne
2240     PRINT#3,CHR$(1);CHR$(20);CHR$(1);
2250     FOR a = 0 TO 59 : PRINT#3,CHR$(dnfnt(a));
2260   END FOR c
2270 END DEFine TO_24PIN_NLQ
